data Addresses;
	input Address & $100.;
	datalines;
200 Cameron Station Blvd
25 W Reed Ave
2701 Commonwealth Ave
5000 Echols Ave
3001 N Beauregard St
5650 Sanger Ave
5651 Rayburn Ave
530 S St Asaph St
215 Las Gaviotas Blvd.
4032 Bunch Walnuts Road
201 Stadium Dr
1116 Hillwell Rd
640 Battlefield Blvd S
298 Cedar Rd
212 Holt Dr
1280 Bells Mill Rd
1200 Cedar Rd
2901 Margaret Booker Dr
509 George Washington Hwy N
;
run;
data Streets;
	input Street $20.;
	datalines;
Blvd
Ave
St
Road
Dr
Hwy
;
run;
proc sort data=addresses;
	by address;
run;
proc sort data=streets;
	by street;
run;
data step1 (keep=address ad_hse_no ad_crdnl_dir ad_str_nm);
	set addresses;
	length AD_HSE_NO 8.;	*AD_HSE_NO is the database column for house number;
	length AD_CRDNL_DIR $2.;	*AD_CRDNL_DIR is the database column for direction;
	length AD_STR_NM $50.;	*AD_STR_NM is the database name for street name;

	a = 1;
	split_count = 0;
	start_pos = 0;

	/* First we need to parse out the address field, putting each element into the array.
	   I'm not sure if there is a better way to do it, this is an adaption of a SQL
	   method I have to do the same thing, and it seems to work fine.
																						*/	   
	do i = 1 to length(trim(address)) + 2;
		if i < length(trim(address) || ' ~') then do;
			if substr(trim(address) || ' ~',i,1) = ' ' then do;
				split_count = split_count + 1;
				if split_count = 1 then do;
					if trim(substr(trim(address),a,i-a)) * 1 = substr(trim(address),a,i-a) then do;
						AD_HSE_NO = substr(trim(address),a,i-a);
					end;
					start_pos = 2;
				end;
				if split_count = 2 then do;
					if trim(substr(trim(address),a,i-a)) in ('E','N','S','W','NE','NW','SE','SW') then do;
						AD_CRDNL_DIR = substr(trim(address),a,i-a);
						start_pos = 3;
					end;
				end;
				if split_count = start_pos then do;
					AD_STR_NM = substr(trim(address),a,i-a);
				end;

				if split_count > start_pos then do;
					if substr(trim(address),a,i-a) in ('Blvd','Ave','St','Road','Dr','Hwy','Blvd.','Rd') then do;
						leave;
					end;
				/* here is where I am stuck.  If we get to 'Rd', 'Ave', etc, I need to leave the loop as
				   I am doing here.  However, I don't want to have to hard code all the possibilities */
						AD_STR_NM = catt(AD_STR_NM,' ' || substr(trim(address),a,i-a));
				end;
				a = i + 1;
			end;
		end;
	end;
run;
